void copia(int V[], int W[], int min, int max)
/* copia W[min,max] in V[min,max] */
{
    int i = min;
    while (i <= max)
        V[i] = W[i++];
}

void merge(int V[], int W[], int min, int m, int max)
/* fonde i vettori ordinati V[min,m] e V[m+1,max]
 * nel vettore W[min,max]
 */
{
    int i = min, j = m+1, k = min;
    while (i <= m && j <= max)
        W[k++] =  (V[i] < V[j]) ? V[i++] : V[j++];
    while (i <= m) W[k++] = V[i++];
    while (j <= max) W[k++] = V[j++];
}

void mergesort(int V[], int W[], int min, int max) 
/* Ordinamento di un vettore V[min,max] per merge sort
 * usando il vettore W come memoria ausiliaria
 * NB. V e W devono essere distinti e della stessa
 *     dimensione.
 */
  
{
    int m = (max+min)/2; /* elemento medio */

    if (min < max) { /* ci sono elementi da ordinare */
        mergesort(V, W, min, m); /* ordina meta' inferiore */
        mergesort(V, W, m+1, max); /* ordina meta' superiore */
        merge(V, W, min, m, max); /* fondi le due parti in W */
        copia(V, W, min, max); /* copia W */
    }
}
